;-----------------------------------------
;IR komunikacija
;oddajnik
;ver 1.0
;www2.maxi.si
;-----------------------------------------

	list P=10f200
	
#include "D:\ASM\P10F200.inc"

#define IZHOD GPIO,0		;izhod
#define TIPKA1 GPIO,3		;tipka1
#define TIPKA2 GPIO,1		;tipka2

#define PODATEK1 'A'		;koda prve tipke
#define PODATEK2 'B' 		;koda druge tipke


	__CONFIG _CP_OFF & _WDT_OFF & _MCLRE_OFF

	cblock 0x10
	TMP,CAS1,T1,T2,TXDATA,STEVEC
	endc

	org 0x0
	movwf OSCCAL
	movlw b'10000111'	;preddelilnik 1/256
	option
	clrw
	clrf GPIO
	movlw b'1110'		;gpio0 je izhod
	tris GPIO
ZANKA
	btfsc TIPKA1		;je tipka 1 stisnjena
	goto TIP2		;ne
	movlw PODATEK1		;da pripravim podatek prve tipke
	call IR_TX		;ter ga posljem
	call P100mS		;pavza ca 100mS pred ponovnim posiljanjem
	goto ZANKA

TIP2	
	btfsc TIPKA2		;je tipka 2 stisnjena
	goto ZANKA		;ne nazaj na tipko1
	movlw PODATEK2		;pripravim podatek druge tipke
	call IR_TX		;ter ga posljem 
	call P100mS		;pavza ca 100mS med ponovnim poslilanjem
	goto ZANKA
	
;----------------------------------------------
;pavza  ca. 100ms
;---------------------------------------------	
P100mS
	movlw .130
	movwf T1
	movlw .221
	movwf T2
Z100mS	
	decfsz T2,f
	goto Z100mS
	decfsz T1,f
	goto Z100mS
	retlw 0	

;----------------------------------
;procedura najprej prolje 
;bit za sinhronizacijo
;nato poslje se 8 bitov
;---------------------------------	
IR_TX
	movwf TXDATA
	movlw .8
	movwf STEVEC
	call BIT1	;bit za sinhronizacijo
Z_TX
	rrf TXDATA,f
	btfss STATUS,C
	goto BIT_1
	call BIT0
	call BIT1
	goto Z_TX2	
BIT_1
	call BIT1
	call BIT0
Z_TX2
	decfsz STEVEC,f
	goto Z_TX
	retlw 0	 
				
;---------------------------------
;procedura generira na IZHOD 
;frekvenco ca 37khz v trajanju 
;ca. 1mS
;--------------------------------- 	
BIT1
	movlw .37
	movwf CAS1	;cas posiljanja je ca 1mS
Z_OSC	
	bsf IZHOD
	movlw .4	;1
	movwf TMP	;2	
	decfsz TMP,f
	goto $-1
	bcf IZHOD	;14
	movlw .3	;15
	movwf TMP	;16	
	decfsz TMP,f
	goto $-1
	decfsz CAS1,f	;;25	
	goto Z_OSC	;26uS
	retlw 0

;------------------------------------------
;pavza ca 1ms
;-----------------------------------------	
BIT0
	movlw .2
	movwf T1
	movlw .74
	movwf T2
Z2	
 	decfsz T2,f
	goto Z2
	decfsz T1,f
	goto Z2
	retlw 0
	
	
	end	;eof
