;-----------------------------------------
;IR komunikacija
;sprejemnik
;Ver. 1.0
;www.maxi.si
;-----------------------------------------

	list P=10f200
	
#include "D:\ASM\P10F200.inc"

#define VHOD GPIO,3
#define RELE GPIO,0

#define KODA1 'A'	;koda prve tipke
#define KODA2 'B'	;koda druge tipke



	__CONFIG _CP_OFF & _WDT_OFF & _MCLRE_OFF

	cblock 0x10
	TMP,CAS1,T1,T2,RXDATA,STEVEC
	endc

	org 0x0
	movwf OSCCAL
	movlw b'10000111'	;preddelilnik 1/256
	option
	clrw
	clrf GPIO
	movlw b'1110'	;
	tris GPIO	;gpio0 je izhod
	call P50mS	;50ms pavze
ZANKA
	btfsc VHOD	;je prisoten signal
	goto ZANKA
	call P500us	;pavza 500uS (sredina sinhro impulza)
	btfsc VHOD	;
	goto RX_ERROR	;napaka pri sinhoronizaciji
	movlw .8
	clrf RXDATA
	movwf STEVEC	;sledi podatek dolzine 8bit	
RX_ZANKA
	call P1mS
	btfss VHOD	;
	goto BIT0
	call P1mS	;pavza 1ms sredina sledecega pol bita
	btfsc VHOD	;slediti mora nizek bit
	goto RX_ERROR
	setc
	rrf RXDATA,f
	decfsz STEVEC,f
	goto RX_ZANKA
	goto KONEC_RX
BIT0
	call P1mS	;pavza 1ms sredina sledecega pol bita
	btfss VHOD	;slediti mora visok bit
	goto RX_ERROR
	clrc
	rrf RXDATA,f
	decfsz STEVEC,f	;je bil sprejet celi 8 bitni niz kode
	goto RX_ZANKA	;ne
KONEC_RX	
	movlw KODA1	
	subwf RXDATA,w	;primerjava nastavljene kode z prejeto
	btfss STATUS,Z	;je enaka?
	goto T_KODA2	;e preverjenje druge kode
	bsf RELE	;da vkljucim rele
	call P50mS	;pocakam ca 50ms
	btfss VHOD	;slucajno ir kaj sprejema?
	goto $-2	;da pocakam se eno dolzino pavze 50mS
	goto ZANKA	;ne nazaj na cakanje prejema kode

T_KODA2
	movlw KODA2	;primerjava druge nastavlene kode z prejeto
	subwf RXDATA,W	;
	btfss STATUS,Z	;se ujemata
	goto RX_ERROR	;ne poslan paket je napacen
	bcf RELE	;da izklopim rele
	call P50mS	;cakam ca 50mS
	btfss VHOD	;Ir slucajno kaj prejema?
	goto $-2	;da zato bom se cakal
	goto ZANKA	;ne nazaj na cakanje
	

RX_ERROR		;napaka med sprejemom
	clrf RXDATA	;obrisem podatek
	call P50mS	;cakam ca 50ms
	btfss VHOD	;ir slucajno kaj prejema
	goto $-2	;da cakanje podalsam
	goto ZANKA	;ne nazaj na cakanje prejema



;----------------------------------------------
;pavza dolzine ca 50ms
;
;---------------------------------------------	
P50mS
	movlw .65
	movwf T1
	movlw .237
	movwf T2
Z50mS	
	decfsz T2,f
	goto Z50mS
	decfsz T1,f
	goto Z50mS
	retlw 0

		
;----------------------------------------------
;pavza dolzine ca 500uS
;---------------------------------------------
P500us
	movlw .164
	movwf T1
ZP500
	decfsz T1,f
	goto ZP500
	goto	$+1
	retlw	0
	
;---------------------------------------------
;pavza dolzine ca 1mS
;--------------------------------------------		
P1mS
	movlw .2
	movwf T1
	movlw .74
	movwf T2
Z2	
 	decfsz T2,f
	goto Z2
	decfsz T1,f
	goto Z2
	retlw 0
	
	
	end	;eof
